import java_cup.runtime.*;

%%	



%class Scanner 		 /* name of the class*/
%function next_token
%type Symbol
%unicode 	  		 /* set of characters (zeichensatz) */
%cup		  		 /* cup compatibility mode */
%line				 /* line counting on(variable yyline)*/
%column		 		 /* column counting on(variable yycolumn)*/

%{	/* Own declarations*/

	private int curr_lineno = 1;
	int get_curr_lineno() {
  		return curr_lineno;
		}

	
	StringBuffer string = new StringBuffer();
	
	private Symbol getSymbol(int type)
	{
		return new Symbol(type, yyline, yycolumn);
	}
	
	private Symbol getSymbol(int type, Object value)
	{
		return new Symbol(type, yyline, yycolumn, value);
	}
%}
characters=	[^\r\n\ \t \_]
linebreak=\r|\n|\r\n 
whitespaces=[\ \t]
%%


                               
  "("                   		{ return getSymbol ( sym.LPAR); }
  ")"                           { return getSymbol ( sym.RPAR); }
  ","							{ return getSymbol ( sym.COMMA);}
  ";"							{ return getSymbol ( sym.SCOLON);}
  {characters}                  { return getSymbol ( sym.CHAR, yytext()); }
  {whitespaces} 				{}
  {linebreak}					{curr_lineno++;}
  <<EOF>>						{ return getSymbol ( sym.EOF);}
  .								{System.err.println("Invalid character \"" + yytext() + "\"" );
  								return getSymbol ( sym.error);}

